package sk.stuba.fei.uim.oop.spring.mvcform;

import lombok.extern.slf4j.Slf4j;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.PostMapping;

@Slf4j
@Controller
@SpringBootApplication
public class MvcFormApplication {

    public static void main(String[] args) {
        SpringApplication.run(MvcFormApplication.class, args);
        log.info("Open in browser: http://localhost:8080");
    }

    @GetMapping
    public String index(Model model) {
        model.addAttribute("item", new Item());
        return "index";
    }

    @PostMapping
    public String submit(@ModelAttribute Item item, Model model) {
        model.addAttribute("item", item);
        return "submitted";
    }
}